/*
 * Aspose.Diagram Cloud API Reference
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 3.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.aspose.cloud.diagram.api;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.aspose.cloud.diagram.client.ApiCallback;
import com.aspose.cloud.diagram.client.ApiClient;
import com.aspose.cloud.diagram.client.ApiException;
import com.aspose.cloud.diagram.client.ApiResponse;
import com.aspose.cloud.diagram.client.Configuration;
import com.aspose.cloud.diagram.client.Pair;
import com.aspose.cloud.diagram.client.ProgressRequestBody;
import com.aspose.cloud.diagram.client.ProgressResponseBody;
import com.aspose.cloud.diagram.model.AccessTokenResponse;
import com.aspose.cloud.diagram.model.ApiResponseOfListOfPageData;
import com.aspose.cloud.diagram.model.CreateNewResponse;
import com.aspose.cloud.diagram.model.EllipseData;
import com.aspose.cloud.diagram.model.LineData;
import com.aspose.cloud.diagram.model.ModifyResponse;
import com.aspose.cloud.diagram.model.PageSetting;
import com.aspose.cloud.diagram.model.PolylineData;
import com.aspose.cloud.diagram.model.SaveAsResponse;
import com.aspose.cloud.diagram.model.SaveOptionsRequest;
import com.google.gson.reflect.TypeToken;

public class DiagramApi {
	private ApiClient apiClient;

	public DiagramApi() {
		this(Configuration.getDefaultApiClient());
	}

	public DiagramApi(ApiClient apiClient) {
		this.apiClient = apiClient;
	}

	public DiagramApi(String grantType, String appSID, String appKey) throws ApiException {
		OAuthApi oAuthApi=new OAuthApi();
		ApiClient oAuthApiClient = new ApiClient();
		oAuthApiClient.setBasePath("https://api.aspose.cloud");
		oAuthApi.setApiClient(oAuthApiClient);	
		AccessTokenResponse response =oAuthApi.oAuthPost(grantType, appSID, appKey);
		String accesstoken = response.getAccessToken();
		
		apiClient= new ApiClient();
		apiClient.setBasePath("https://api.aspose.cloud/v3.0");
		//apiClient.setBasePath("http://localhost:8888");
		apiClient.addDefaultHeader("Authorization", "Bearer " + accesstoken);
		setApiClient(apiClient);
	}

	public ApiClient getApiClient() {
		return apiClient;
	}

	public void setApiClient(ApiClient apiClient) {
		this.apiClient = apiClient;
	}

	/**
	 * Build call for convertDocument
	 * 
	 * @param name
	 *            Download document name. (required)
	 * @param file
	 *            File to upload (required)
	 * @param sourceFilename
	 *            Source document name. (optional)
	 * @param progressListener
	 *            Progress listener
	 * @param progressRequestListener
	 *            Progress request listener
	 * @return Call to execute
	 * @throws ApiException
	 *             If fail to serialize the request body object
	 */
	public com.squareup.okhttp.Call convertDocumentCall(String name, File file, String sourceFilename,
			final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
		Object localVarPostBody = null;

		// create path and map variables
		String localVarPath = "/diagram/{name}/convert".replaceAll("\\{" + "name" + "\\}",
				apiClient.escapeString(name.toString()));

		List<Pair> localVarQueryParams = new ArrayList<Pair>();
		if (sourceFilename != null)
			localVarQueryParams.addAll(apiClient.parameterToPairs("", "sourceFilename", sourceFilename));

		Map<String, String> localVarHeaderParams = new HashMap<String, String>();

		Map<String, Object> localVarFormParams = new HashMap<String, Object>();
		if (file != null)
			localVarFormParams.put("File", file);

		final String[] localVarAccepts = { "multipart/form-data" };
		final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
		if (localVarAccept != null)
			localVarHeaderParams.put("Accept", localVarAccept);

		final String[] localVarContentTypes = { "multipart/form-data" };
		final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
		localVarHeaderParams.put("Content-Type", localVarContentType);

		if (progressListener != null) {
			apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
				@Override
				public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain)
						throws IOException {
					com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
					return originalResponse.newBuilder()
							.body(new ProgressResponseBody(originalResponse.body(), progressListener)).build();
				}
			});
		}

		String[] localVarAuthNames = new String[] { "JWT" };
		return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams,
				localVarFormParams, localVarAuthNames, progressRequestListener);
	}

	@SuppressWarnings("rawtypes")
	private com.squareup.okhttp.Call convertDocumentValidateBeforeCall(String name, File file, String sourceFilename,
			final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {

		// verify the required parameter 'name' is set
		if (name == null) {
			throw new ApiException("Missing the required parameter 'name' when calling convertDocument(Async)");
		}

		// verify the required parameter 'file' is set
		if (file == null) {
			throw new ApiException("Missing the required parameter 'file' when calling convertDocument(Async)");
		}

		com.squareup.okhttp.Call call = convertDocumentCall(name, file, sourceFilename, progressListener,
				progressRequestListener);
		return call;

	}

	/**
	 * Converts document from the request&#39;s content to the specified format.
	 * 
	 * @param name
	 *            Download document name. (required)
	 * @param file
	 *            File to upload (required)
	 * @param sourceFilename
	 *            Source document name. (optional)
	 * @return File
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public File convertDocument(String name, File file, String sourceFilename) throws ApiException {
		ApiResponse<File> resp = convertDocumentWithHttpInfo(name, file, sourceFilename);
		return resp.getData();
	}

	/**
	 * Converts document from the request&#39;s content to the specified format.
	 * 
	 * @param name
	 *            Download document name. (required)
	 * @param file
	 *            File to upload (required)
	 * @param sourceFilename
	 *            Source document name. (optional)
	 * @return ApiResponse&lt;File&gt;
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public ApiResponse<File> convertDocumentWithHttpInfo(String name, File file, String sourceFilename)
			throws ApiException {
		com.squareup.okhttp.Call call = convertDocumentValidateBeforeCall(name, file, sourceFilename, null, null);
		Type localVarReturnType = new TypeToken<File>() {
		}.getType();
		return apiClient.execute(call, localVarReturnType);
	}

	/**
	 * Converts document from the request&#39;s content to the specified format.
	 * (asynchronously)
	 * 
	 * @param name
	 *            Download document name. (required)
	 * @param file
	 *            File to upload (required)
	 * @param sourceFilename
	 *            Source document name. (optional)
	 * @param callback
	 *            The callback to be executed when the API call finishes
	 * @return The request call
	 * @throws ApiException
	 *             If fail to process the API call, e.g. serializing the request
	 *             body object
	 */
	public com.squareup.okhttp.Call convertDocumentAsync(String name, File file, String sourceFilename,
			final ApiCallback<File> callback) throws ApiException {

		ProgressResponseBody.ProgressListener progressListener = null;
		ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

		if (callback != null) {
			progressListener = new ProgressResponseBody.ProgressListener() {
				@Override
				public void update(long bytesRead, long contentLength, boolean done) {
					callback.onDownloadProgress(bytesRead, contentLength, done);
				}
			};

			progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
				@Override
				public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
					callback.onUploadProgress(bytesWritten, contentLength, done);
				}
			};
		}

		com.squareup.okhttp.Call call = convertDocumentValidateBeforeCall(name, file, sourceFilename, progressListener,
				progressRequestListener);
		Type localVarReturnType = new TypeToken<File>() {
		}.getType();
		apiClient.executeAsync(call, localVarReturnType, callback);
		return call;
	}

	/**
	 * Build call for createNew
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param folder
	 *            The document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @param progressListener
	 *            Progress listener
	 * @param progressRequestListener
	 *            Progress request listener
	 * @return Call to execute
	 * @throws ApiException
	 *             If fail to serialize the request body object
	 */
	public com.squareup.okhttp.Call createNewCall(String name, String folder, Boolean isOverwrite,
			final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
		Object localVarPostBody = null;

		// create path and map variables
		String localVarPath = "/diagram/{name}".replaceAll("\\{" + "name" + "\\}",
				apiClient.escapeString(name.toString()));

		List<Pair> localVarQueryParams = new ArrayList<Pair>();
		if (folder != null)
			localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));
		if (isOverwrite != null)
			localVarQueryParams.addAll(apiClient.parameterToPairs("", "IsOverwrite", isOverwrite));

		Map<String, String> localVarHeaderParams = new HashMap<String, String>();

		Map<String, Object> localVarFormParams = new HashMap<String, Object>();

		final String[] localVarAccepts = { "application/json" };
		final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
		if (localVarAccept != null)
			localVarHeaderParams.put("Accept", localVarAccept);

		final String[] localVarContentTypes = { "application/json" };
		final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
		localVarHeaderParams.put("Content-Type", localVarContentType);

		if (progressListener != null) {
			apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
				@Override
				public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain)
						throws IOException {
					com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
					return originalResponse.newBuilder()
							.body(new ProgressResponseBody(originalResponse.body(), progressListener)).build();
				}
			});
		}

		String[] localVarAuthNames = new String[] { "JWT" };
		return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams,
				localVarFormParams, localVarAuthNames, progressRequestListener);
	}

	@SuppressWarnings("rawtypes")
	private com.squareup.okhttp.Call createNewValidateBeforeCall(String name, String folder, Boolean isOverwrite,
			final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {

		// verify the required parameter 'name' is set
		if (name == null) {
			throw new ApiException("Missing the required parameter 'name' when calling createNew(Async)");
		}

		com.squareup.okhttp.Call call = createNewCall(name, folder, isOverwrite, progressListener,
				progressRequestListener);
		return call;

	}

	/**
	 * Create Empty file into the specified format.
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param folder
	 *            The document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @return CreateNewResponse
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public CreateNewResponse createNew(String name, String folder, Boolean isOverwrite) throws ApiException {
		ApiResponse<CreateNewResponse> resp = createNewWithHttpInfo(name, folder, isOverwrite);
		return resp.getData();
	}

	/**
	 * Create Empty file into the specified format.
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param folder
	 *            The document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @return ApiResponse&lt;CreateNewResponse&gt;
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public ApiResponse<CreateNewResponse> createNewWithHttpInfo(String name, String folder, Boolean isOverwrite)
			throws ApiException {
		com.squareup.okhttp.Call call = createNewValidateBeforeCall(name, folder, isOverwrite, null, null);
		Type localVarReturnType = new TypeToken<CreateNewResponse>() {
		}.getType();
		return apiClient.execute(call, localVarReturnType);
	}

	/**
	 * Create Empty file into the specified format. (asynchronously)
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param folder
	 *            The document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @param callback
	 *            The callback to be executed when the API call finishes
	 * @return The request call
	 * @throws ApiException
	 *             If fail to process the API call, e.g. serializing the request
	 *             body object
	 */
	public com.squareup.okhttp.Call createNewAsync(String name, String folder, Boolean isOverwrite,
			final ApiCallback<CreateNewResponse> callback) throws ApiException {

		ProgressResponseBody.ProgressListener progressListener = null;
		ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

		if (callback != null) {
			progressListener = new ProgressResponseBody.ProgressListener() {
				@Override
				public void update(long bytesRead, long contentLength, boolean done) {
					callback.onDownloadProgress(bytesRead, contentLength, done);
				}
			};

			progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
				@Override
				public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
					callback.onUploadProgress(bytesWritten, contentLength, done);
				}
			};
		}

		com.squareup.okhttp.Call call = createNewValidateBeforeCall(name, folder, isOverwrite, progressListener,
				progressRequestListener);
		Type localVarReturnType = new TypeToken<CreateNewResponse>() {
		}.getType();
		apiClient.executeAsync(call, localVarReturnType, callback);
		return call;
	}

	/**
	 * Build call for downloadFileWithFormat
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param format
	 *            The destination format. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @param progressListener
	 *            Progress listener
	 * @param progressRequestListener
	 *            Progress request listener
	 * @return Call to execute
	 * @throws ApiException
	 *             If fail to serialize the request body object
	 */
	public com.squareup.okhttp.Call downloadFileWithFormatCall(String name, String format, String folder,
			final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
		Object localVarPostBody = null;

		// create path and map variables
		String localVarPath = "/diagram/{name}".replaceAll("\\{" + "name" + "\\}",
				apiClient.escapeString(name.toString()));

		List<Pair> localVarQueryParams = new ArrayList<Pair>();
		if (format != null)
			localVarQueryParams.addAll(apiClient.parameterToPairs("", "format", format));
		if (folder != null)
			localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

		Map<String, String> localVarHeaderParams = new HashMap<String, String>();

		Map<String, Object> localVarFormParams = new HashMap<String, Object>();

		final String[] localVarAccepts = { "multipart/form-data" };
		final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
		if (localVarAccept != null)
			localVarHeaderParams.put("Accept", localVarAccept);

		final String[] localVarContentTypes = { "application/json" };
		final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
		localVarHeaderParams.put("Content-Type", localVarContentType);

		if (progressListener != null) {
			apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
				@Override
				public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain)
						throws IOException {
					com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
					return originalResponse.newBuilder()
							.body(new ProgressResponseBody(originalResponse.body(), progressListener)).build();
				}
			});
		}

		String[] localVarAuthNames = new String[] { "JWT" };
		return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams,
				localVarFormParams, localVarAuthNames, progressRequestListener);
	}

	@SuppressWarnings("rawtypes")
	private com.squareup.okhttp.Call downloadFileWithFormatValidateBeforeCall(String name, String format, String folder,
			final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {

		// verify the required parameter 'name' is set
		if (name == null) {
			throw new ApiException("Missing the required parameter 'name' when calling downloadFileWithFormat(Async)");
		}

		// verify the required parameter 'format' is set
		if (format == null) {
			throw new ApiException(
					"Missing the required parameter 'format' when calling downloadFileWithFormat(Async)");
		}

		com.squareup.okhttp.Call call = downloadFileWithFormatCall(name, format, folder, progressListener,
				progressRequestListener);
		return call;

	}

	/**
	 * Exports the document into the specified format.
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param format
	 *            The destination format. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @return File
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public File downloadFileWithFormat(String name, String format, String folder) throws ApiException {
		ApiResponse<File> resp = downloadFileWithFormatWithHttpInfo(name, format, folder);
		return resp.getData();
	}

	/**
	 * Exports the document into the specified format.
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param format
	 *            The destination format. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @return ApiResponse&lt;File&gt;
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public ApiResponse<File> downloadFileWithFormatWithHttpInfo(String name, String format, String folder)
			throws ApiException {
		com.squareup.okhttp.Call call = downloadFileWithFormatValidateBeforeCall(name, format, folder, null, null);
		Type localVarReturnType = new TypeToken<File>() {
		}.getType();
		return apiClient.execute(call, localVarReturnType);
	}

	/**
	 * Exports the document into the specified format. (asynchronously)
	 * 
	 * @param name
	 *            The document name. (required)
	 * @param format
	 *            The destination format. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @param callback
	 *            The callback to be executed when the API call finishes
	 * @return The request call
	 * @throws ApiException
	 *             If fail to process the API call, e.g. serializing the request
	 *             body object
	 */
	public com.squareup.okhttp.Call downloadFileWithFormatAsync(String name, String format, String folder,
			final ApiCallback<File> callback) throws ApiException {

		ProgressResponseBody.ProgressListener progressListener = null;
		ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

		if (callback != null) {
			progressListener = new ProgressResponseBody.ProgressListener() {
				@Override
				public void update(long bytesRead, long contentLength, boolean done) {
					callback.onDownloadProgress(bytesRead, contentLength, done);
				}
			};

			progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
				@Override
				public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
					callback.onUploadProgress(bytesWritten, contentLength, done);
				}
			};
		}

		com.squareup.okhttp.Call call = downloadFileWithFormatValidateBeforeCall(name, format, folder, progressListener,
				progressRequestListener);
		Type localVarReturnType = new TypeToken<File>() {
		}.getType();
		apiClient.executeAsync(call, localVarReturnType, callback);
		return call;
	}

	/**
	 * Build call for saveAs
	 * 
	 * @param name
	 *            Original document name. (required)
	 * @param saveOptionsRequest
	 *            Save options. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @param progressListener
	 *            Progress listener
	 * @param progressRequestListener
	 *            Progress request listener
	 * @return Call to execute
	 * @throws ApiException
	 *             If fail to serialize the request body object
	 */
	public com.squareup.okhttp.Call saveAsCall(String name, SaveOptionsRequest saveOptionsRequest, String folder,
			Boolean isOverwrite, final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
		Object localVarPostBody = saveOptionsRequest;

		// create path and map variables
		String localVarPath = "/diagram/{name}/saveAs".replaceAll("\\{" + "name" + "\\}",
				apiClient.escapeString(name.toString()));

		List<Pair> localVarQueryParams = new ArrayList<Pair>();
		if (folder != null)
			localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));
		if (isOverwrite != null)
			localVarQueryParams.addAll(apiClient.parameterToPairs("", "IsOverwrite", isOverwrite));

		Map<String, String> localVarHeaderParams = new HashMap<String, String>();

		Map<String, Object> localVarFormParams = new HashMap<String, Object>();

		final String[] localVarAccepts = { "application/json" };
		final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
		if (localVarAccept != null)
			localVarHeaderParams.put("Accept", localVarAccept);

		final String[] localVarContentTypes = { "application/json" };
		final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
		localVarHeaderParams.put("Content-Type", localVarContentType);

		if (progressListener != null) {
			apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
				@Override
				public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain)
						throws IOException {
					com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
					return originalResponse.newBuilder()
							.body(new ProgressResponseBody(originalResponse.body(), progressListener)).build();
				}
			});
		}

		String[] localVarAuthNames = new String[] { "JWT" };
		return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams,
				localVarFormParams, localVarAuthNames, progressRequestListener);
	}

	@SuppressWarnings("rawtypes")
	private com.squareup.okhttp.Call saveAsValidateBeforeCall(String name, SaveOptionsRequest saveOptionsRequest,
			String folder, Boolean isOverwrite, final ProgressResponseBody.ProgressListener progressListener,
			final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {

		// verify the required parameter 'name' is set
		if (name == null) {
			throw new ApiException("Missing the required parameter 'name' when calling saveAs(Async)");
		}

		// verify the required parameter 'saveOptionsRequest' is set
		if (saveOptionsRequest == null) {
			throw new ApiException("Missing the required parameter 'saveOptionsRequest' when calling saveAs(Async)");
		}

		com.squareup.okhttp.Call call = saveAsCall(name, saveOptionsRequest, folder, isOverwrite, progressListener,
				progressRequestListener);
		return call;

	}

	/**
	 * Converts document to destination format with detailed settings and saves
	 * result to storage.
	 * 
	 * @param name
	 *            Original document name. (required)
	 * @param saveOptionsRequest
	 *            Save options. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @return SaveAsResponse
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public SaveAsResponse saveAs(String name, SaveOptionsRequest saveOptionsRequest, String folder, Boolean isOverwrite)
			throws ApiException {
		ApiResponse<SaveAsResponse> resp = saveAsWithHttpInfo(name, saveOptionsRequest, folder, isOverwrite);
		return resp.getData();
	}

	/**
	 * Converts document to destination format with detailed settings and saves
	 * result to storage.
	 * 
	 * @param name
	 *            Original document name. (required)
	 * @param saveOptionsRequest
	 *            Save options. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @return ApiResponse&lt;SaveAsResponse&gt;
	 * @throws ApiException
	 *             If fail to call the API, e.g. server error or cannot deserialize
	 *             the response body
	 */
	public ApiResponse<SaveAsResponse> saveAsWithHttpInfo(String name, SaveOptionsRequest saveOptionsRequest,
			String folder, Boolean isOverwrite) throws ApiException {
		com.squareup.okhttp.Call call = saveAsValidateBeforeCall(name, saveOptionsRequest, folder, isOverwrite, null,
				null);
		Type localVarReturnType = new TypeToken<SaveAsResponse>() {
		}.getType();
		return apiClient.execute(call, localVarReturnType);
	}

	/**
	 * Converts document to destination format with detailed settings and saves
	 * result to storage. (asynchronously)
	 * 
	 * @param name
	 *            Original document name. (required)
	 * @param saveOptionsRequest
	 *            Save options. (required)
	 * @param folder
	 *            Original document folder. (optional)
	 * @param isOverwrite
	 *            If true overwrite the same name file.The default value is false
	 *            (optional, default to false)
	 * @param callback
	 *            The callback to be executed when the API call finishes
	 * @return The request call
	 * @throws ApiException
	 *             If fail to process the API call, e.g. serializing the request
	 *             body object
	 */
	public com.squareup.okhttp.Call saveAsAsync(String name, SaveOptionsRequest saveOptionsRequest, String folder,
			Boolean isOverwrite, final ApiCallback<SaveAsResponse> callback) throws ApiException {

		ProgressResponseBody.ProgressListener progressListener = null;
		ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

		if (callback != null) {
			progressListener = new ProgressResponseBody.ProgressListener() {
				@Override
				public void update(long bytesRead, long contentLength, boolean done) {
					callback.onDownloadProgress(bytesRead, contentLength, done);
				}
			};

			progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
				@Override
				public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
					callback.onUploadProgress(bytesWritten, contentLength, done);
				}
			};
		}

		com.squareup.okhttp.Call call = saveAsValidateBeforeCall(name, saveOptionsRequest, folder, isOverwrite,
				progressListener, progressRequestListener);
		Type localVarReturnType = new TypeToken<SaveAsResponse>() {
		}.getType();
		apiClient.executeAsync(call, localVarReturnType, callback);
		return call;
	}
	
	 /**
     * Build call for putDrawEllipse
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param ellipseData drawing ellipse data. (required)
     * @param folder Document folder. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putDrawEllipseCall(String name, String pageName, EllipseData ellipseData, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = ellipseData;
        
        // create path and map variables
        String localVarPath = "/diagram/{name}/pages/{pageName}/drawEllipse"
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()))
            .replaceAll("\\{" + "pageName" + "\\}", apiClient.escapeString(pageName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (folder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "JWT" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putDrawEllipseValidateBeforeCall(String name, String pageName, EllipseData ellipseData, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling putDrawEllipse(Async)");
        }
        
        // verify the required parameter 'pageName' is set
        if (pageName == null) {
            throw new ApiException("Missing the required parameter 'pageName' when calling putDrawEllipse(Async)");
        }
        
        // verify the required parameter 'ellipseData' is set
        if (ellipseData == null) {
            throw new ApiException("Missing the required parameter 'ellipseData' when calling putDrawEllipse(Async)");
        }
        
        
        com.squareup.okhttp.Call call = putDrawEllipseCall(name, pageName, ellipseData, folder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * draw ellipse on the page.
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param ellipseData drawing ellipse data. (required)
     * @param folder Document folder. (optional)
     * @return ModifyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModifyResponse putDrawEllipse(String name, String pageName, EllipseData ellipseData, String folder) throws ApiException {
        ApiResponse<ModifyResponse> resp = putDrawEllipseWithHttpInfo(name, pageName, ellipseData, folder);
        return resp.getData();
    }

    /**
     * draw ellipse on the page.
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param ellipseData drawing ellipse data. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponse&lt;ModifyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModifyResponse> putDrawEllipseWithHttpInfo(String name, String pageName, EllipseData ellipseData, String folder) throws ApiException {
        com.squareup.okhttp.Call call = putDrawEllipseValidateBeforeCall(name, pageName, ellipseData, folder, null, null);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * draw ellipse on the page. (asynchronously)
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param ellipseData drawing ellipse data. (required)
     * @param folder Document folder. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putDrawEllipseAsync(String name, String pageName, EllipseData ellipseData, String folder, final ApiCallback<ModifyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putDrawEllipseValidateBeforeCall(name, pageName, ellipseData, folder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for putDrawLine
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param lineData drawing line data. (required)
     * @param folder Document folder. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putDrawLineCall(String name, String pageName, LineData lineData, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = lineData;
        
        // create path and map variables
        String localVarPath = "/diagram/{name}/pages/{pageName}/drawLine"
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()))
            .replaceAll("\\{" + "pageName" + "\\}", apiClient.escapeString(pageName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (folder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "JWT" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putDrawLineValidateBeforeCall(String name, String pageName, LineData lineData, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling putDrawLine(Async)");
        }
        
        // verify the required parameter 'pageName' is set
        if (pageName == null) {
            throw new ApiException("Missing the required parameter 'pageName' when calling putDrawLine(Async)");
        }
        
        // verify the required parameter 'lineData' is set
        if (lineData == null) {
            throw new ApiException("Missing the required parameter 'lineData' when calling putDrawLine(Async)");
        }
        
        
        com.squareup.okhttp.Call call = putDrawLineCall(name, pageName, lineData, folder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * draw line on the page.
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param lineData drawing line data. (required)
     * @param folder Document folder. (optional)
     * @return ModifyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModifyResponse putDrawLine(String name, String pageName, LineData lineData, String folder) throws ApiException {
        ApiResponse<ModifyResponse> resp = putDrawLineWithHttpInfo(name, pageName, lineData, folder);
        return resp.getData();
    }

    /**
     * draw line on the page.
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param lineData drawing line data. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponse&lt;ModifyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModifyResponse> putDrawLineWithHttpInfo(String name, String pageName, LineData lineData, String folder) throws ApiException {
        com.squareup.okhttp.Call call = putDrawLineValidateBeforeCall(name, pageName, lineData, folder, null, null);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * draw line on the page. (asynchronously)
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param lineData drawing line data. (required)
     * @param folder Document folder. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putDrawLineAsync(String name, String pageName, LineData lineData, String folder, final ApiCallback<ModifyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putDrawLineValidateBeforeCall(name, pageName, lineData, folder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for putDrawPolyline
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param polylineData drawing polyline data. (required)
     * @param folder Document folder. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putDrawPolylineCall(String name, String pageName, PolylineData polylineData, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = polylineData;
        
        // create path and map variables
        String localVarPath = "/diagram/{name}/pages/{pageName}/drawPolyline"
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()))
            .replaceAll("\\{" + "pageName" + "\\}", apiClient.escapeString(pageName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (folder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "JWT" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putDrawPolylineValidateBeforeCall(String name, String pageName, PolylineData polylineData, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling putDrawPolyline(Async)");
        }
        
        // verify the required parameter 'pageName' is set
        if (pageName == null) {
            throw new ApiException("Missing the required parameter 'pageName' when calling putDrawPolyline(Async)");
        }
        
        // verify the required parameter 'polylineData' is set
        if (polylineData == null) {
            throw new ApiException("Missing the required parameter 'polylineData' when calling putDrawPolyline(Async)");
        }
        
        
        com.squareup.okhttp.Call call = putDrawPolylineCall(name, pageName, polylineData, folder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * draw polyline on the page.
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param polylineData drawing polyline data. (required)
     * @param folder Document folder. (optional)
     * @return ModifyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModifyResponse putDrawPolyline(String name, String pageName, PolylineData polylineData, String folder) throws ApiException {
        ApiResponse<ModifyResponse> resp = putDrawPolylineWithHttpInfo(name, pageName, polylineData, folder);
        return resp.getData();
    }

    /**
     * draw polyline on the page.
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param polylineData drawing polyline data. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponse&lt;ModifyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModifyResponse> putDrawPolylineWithHttpInfo(String name, String pageName, PolylineData polylineData, String folder) throws ApiException {
        com.squareup.okhttp.Call call = putDrawPolylineValidateBeforeCall(name, pageName, polylineData, folder, null, null);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * draw polyline on the page. (asynchronously)
     * 
     * @param name Document name. (required)
     * @param pageName Page name. (required)
     * @param polylineData drawing polyline data. (required)
     * @param folder Document folder. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putDrawPolylineAsync(String name, String pageName, PolylineData polylineData, String folder, final ApiCallback<ModifyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putDrawPolylineValidateBeforeCall(name, pageName, polylineData, folder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    
    /**
     * Build call for deletePage
     * @param name Document name. (required)
     * @param pageName The page name for delete. (required)
     * @param folder Document folder. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deletePageCall(String name, String pageName, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/diagram/{name}/pages/{pageName}"
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()))
            .replaceAll("\\{" + "pageName" + "\\}", apiClient.escapeString(pageName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (folder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "JWT" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deletePageValidateBeforeCall(String name, String pageName, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling deletePage(Async)");
        }
        
        // verify the required parameter 'pageName' is set
        if (pageName == null) {
            throw new ApiException("Missing the required parameter 'pageName' when calling deletePage(Async)");
        }
        
        
        com.squareup.okhttp.Call call = deletePageCall(name, pageName, folder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Remove Page
     * 
     * @param name Document name. (required)
     * @param pageName The page name for delete. (required)
     * @param folder Document folder. (optional)
     * @return ModifyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModifyResponse deletePage(String name, String pageName, String folder) throws ApiException {
        ApiResponse<ModifyResponse> resp = deletePageWithHttpInfo(name, pageName, folder);
        return resp.getData();
    }

    /**
     * Remove Page
     * 
     * @param name Document name. (required)
     * @param pageName The page name for delete. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponse&lt;ModifyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModifyResponse> deletePageWithHttpInfo(String name, String pageName, String folder) throws ApiException {
        com.squareup.okhttp.Call call = deletePageValidateBeforeCall(name, pageName, folder, null, null);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Remove Page (asynchronously)
     * 
     * @param name Document name. (required)
     * @param pageName The page name for delete. (required)
     * @param folder Document folder. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deletePageAsync(String name, String pageName, String folder, final ApiCallback<ModifyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deletePageValidateBeforeCall(name, pageName, folder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getPages
     * @param name Document name. (required)
     * @param folder Document folder. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getPagesCall(String name, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/diagram/{name}/pages"
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (folder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "JWT" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getPagesValidateBeforeCall(String name, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling getPages(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getPagesCall(name, folder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Read pages info.
     * 
     * @param name Document name. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponseOfListOfPageData
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponseOfListOfPageData getPages(String name, String folder) throws ApiException {
        ApiResponse<ApiResponseOfListOfPageData> resp = getPagesWithHttpInfo(name, folder);
        return resp.getData();
    }

    /**
     * Read pages info.
     * 
     * @param name Document name. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponse&lt;ApiResponseOfListOfPageData&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiResponseOfListOfPageData> getPagesWithHttpInfo(String name, String folder) throws ApiException {
        com.squareup.okhttp.Call call = getPagesValidateBeforeCall(name, folder, null, null);
        Type localVarReturnType = new TypeToken<ApiResponseOfListOfPageData>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Read pages info. (asynchronously)
     * 
     * @param name Document name. (required)
     * @param folder Document folder. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getPagesAsync(String name, String folder, final ApiCallback<ApiResponseOfListOfPageData> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getPagesValidateBeforeCall(name, folder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiResponseOfListOfPageData>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for postPageSetup
     * @param name Document name. (required)
     * @param pageName The page name for setting. (required)
     * @param pageSetting Page setting info. (required)
     * @param folder Document folder. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call postPageSetupCall(String name, String pageName, PageSetting pageSetting, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = pageSetting;
        
        // create path and map variables
        String localVarPath = "/diagram/{name}/pages/PageSetup"
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageName != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageName", pageName));
        if (folder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "JWT" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postPageSetupValidateBeforeCall(String name, String pageName, PageSetting pageSetting, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling postPageSetup(Async)");
        }
        
        // verify the required parameter 'pageName' is set
        if (pageName == null) {
            throw new ApiException("Missing the required parameter 'pageName' when calling postPageSetup(Async)");
        }
        
        // verify the required parameter 'pageSetting' is set
        if (pageSetting == null) {
            throw new ApiException("Missing the required parameter 'pageSetting' when calling postPageSetup(Async)");
        }
        
        
        com.squareup.okhttp.Call call = postPageSetupCall(name, pageName, pageSetting, folder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * page setup
     * 
     * @param name Document name. (required)
     * @param pageName The page name for setting. (required)
     * @param pageSetting Page setting info. (required)
     * @param folder Document folder. (optional)
     * @return ModifyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModifyResponse postPageSetup(String name, String pageName, PageSetting pageSetting, String folder) throws ApiException {
        ApiResponse<ModifyResponse> resp = postPageSetupWithHttpInfo(name, pageName, pageSetting, folder);
        return resp.getData();
    }

    /**
     * page setup
     * 
     * @param name Document name. (required)
     * @param pageName The page name for setting. (required)
     * @param pageSetting Page setting info. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponse&lt;ModifyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModifyResponse> postPageSetupWithHttpInfo(String name, String pageName, PageSetting pageSetting, String folder) throws ApiException {
        com.squareup.okhttp.Call call = postPageSetupValidateBeforeCall(name, pageName, pageSetting, folder, null, null);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * page setup (asynchronously)
     * 
     * @param name Document name. (required)
     * @param pageName The page name for setting. (required)
     * @param pageSetting Page setting info. (required)
     * @param folder Document folder. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postPageSetupAsync(String name, String pageName, PageSetting pageSetting, String folder, final ApiCallback<ModifyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postPageSetupValidateBeforeCall(name, pageName, pageSetting, folder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for putNewPage
     * @param name Document name. (required)
     * @param pageName New page name. (required)
     * @param folder Document folder. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putNewPageCall(String name, String pageName, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/diagram/{name}/pages/addNew"
            .replaceAll("\\{" + "name" + "\\}", apiClient.escapeString(name.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (pageName != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "pageName", pageName));
        if (folder != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "folder", folder));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "JWT" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putNewPageValidateBeforeCall(String name, String pageName, String folder, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling putNewPage(Async)");
        }
        
        // verify the required parameter 'pageName' is set
        if (pageName == null) {
            throw new ApiException("Missing the required parameter 'pageName' when calling putNewPage(Async)");
        }
        
        
        com.squareup.okhttp.Call call = putNewPageCall(name, pageName, folder, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Add new empty page
     * 
     * @param name Document name. (required)
     * @param pageName New page name. (required)
     * @param folder Document folder. (optional)
     * @return ModifyResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModifyResponse putNewPage(String name, String pageName, String folder) throws ApiException {
        ApiResponse<ModifyResponse> resp = putNewPageWithHttpInfo(name, pageName, folder);
        return resp.getData();
    }

    /**
     * Add new empty page
     * 
     * @param name Document name. (required)
     * @param pageName New page name. (required)
     * @param folder Document folder. (optional)
     * @return ApiResponse&lt;ModifyResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModifyResponse> putNewPageWithHttpInfo(String name, String pageName, String folder) throws ApiException {
        com.squareup.okhttp.Call call = putNewPageValidateBeforeCall(name, pageName, folder, null, null);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Add new empty page (asynchronously)
     * 
     * @param name Document name. (required)
     * @param pageName New page name. (required)
     * @param folder Document folder. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putNewPageAsync(String name, String pageName, String folder, final ApiCallback<ModifyResponse> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putNewPageValidateBeforeCall(name, pageName, folder, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModifyResponse>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
